package sialocacao;

/**
 * <p>Title: SIAlocacaoException.java </p>
 * <p>Description: Responsvel pelas excees do sistema. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira 
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import java.io.*;

public class SIAlocacaoException extends Exception {

  /*
   * Descrio da exceo levantada.
   */	
  private String description;

  /*
   * Exceo.
   */	
  private Throwable exception;

  /*
   * Construtor responsvel por definir a descrio e exceo levantada.
   */	
  public SIAlocacaoException(String description, Throwable exception) {
    setDescription(description);
    setException(exception);
  }

  /*
   * Construtor responsvel por definir a descrio da exceo levantada.
   */	
  public SIAlocacaoException(String description) {
    super(description);
  }

  /*
   * Construtor vazio.
   */	
  public SIAlocacaoException() {}

  /*
   * Define descrio da exceo.
   * @param description
   */	
  public void setDescription(String description) {
    this.description = description;
  }

  /*
   * Pega descrio da exceo.
   * @param String
   */	
  public String getDescription() {
    return description;
  }

  /*
   * Define exceo do sistema.
   * @param exception
   */	
  public void setException(Throwable exception) {
    this.exception = exception;
  }

  /*
   * Pega exceo do sistema.
   * @param String
   */	
  public Throwable getException() {
    return exception;
  }

  /*
   * Sada da exceo para os sistema.
   * @param output
   */	
  public void printStackTrace(PrintStream output) {
    if (output == null) {
      throw new IllegalArgumentException("output == null");
    }
    super.printStackTrace(output);
    if (exception != null) {
      output.println("Exception: ");
      exception.printStackTrace(output);
    }
  }

  /*
   * Sada da exceo para os sistema.
   * @param output
   */	
  public void printStackTrace(PrintWriter output) {
    if (output == null) {
      throw new IllegalArgumentException("output == null");
    }
    super.printStackTrace(output);
    if (exception != null) {
      output.println("Exception: ");
      exception.printStackTrace(output);
    }
  }
}