package sialocacao.sala.servlets;


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import sialocacao.*;

import sialocacao.professor.negocio.*;
import sialocacao.professor.database.*;

import sialocacao.disciplina.negocio.*;
import sialocacao.disciplina.database.*;

import sialocacao.sala.negocio.*;
import sialocacao.sala.database.*;

import sialocacao.horario.negocio.*;
import sialocacao.horario.database.*;

/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author fabrica03
 * @version 1.0
 */

public class ServletCadastrarSala extends HttpServlet{
  public void doGet( HttpServletRequest req,
                     HttpServletResponse res )
    throws ServletException, IOException{

    doPost(req, res);
  }

  public void doPost( HttpServletRequest req,
                      HttpServletResponse res )
    throws ServletException, IOException{

    String descricao = req.getParameter( "descricao" );
    String localizacao = req.getParameter( "localizacao" );
    String observacao = req.getParameter( "observacao" );

    HttpSession session =
      req.getSession(true);

    try{
      CadastroProfessores cadastroProfessores =
        new CadastroProfessores(new ProfessorDatabase());
      CadastroDisciplinas cadastroDisciplinas =
        new CadastroDisciplinas(new DisciplinaDatabase());
      CadastroSalas cadastroSalas =
        new CadastroSalas(new SalaDatabase());
      CadastroHorarios cadastroHorarios =
        new CadastroHorarios(new HorarioDatabase());

      SIAlocacao sialocacao =
        new SIAlocacao(cadastroProfessores, cadastroDisciplinas,
                       cadastroSalas, cadastroHorarios);

      sialocacao.inserirSala(descricao, localizacao, observacao);

      session.setAttribute("sucesso_mensagem",
        "Sala cadastrada com sucesso!!!");

      res.sendRedirect("/sialocacao/jsp/sucesso.jsp");

      return;
    }catch(Exception ex){ex.printStackTrace();
       session.setAttribute("erro_mensagem",
        "Problemas ao realizar operao!!!");

       res.sendRedirect("/sialocacao/jsp/erro.jsp");

       return;
     }
  }
}
