package sialocacao.alocacao.database;

import java.util.*;
import sialocacao.*;
import sialocacao.alocacao.*;
import sialocacao.alocacao.excecoes.*;

import sialocacao.professor.*;
import sialocacao.disciplina.*;
import sialocacao.sala.*;
import sialocacao.horario.*;


/**
 * <p>Title: IAlocacaoDatabase.java </p>
 * <p>Description: Interface da classe AlocacaoDatabase.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III</p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public interface IAlocacaoDatabase {

  /*
   * Insere uma Alocacao no sistema.
   * @param horario
   * @param sala
   * @param disciplina
   * @param professor
   */
  public void alocar(Horario horario, Sala sala, Disciplina disciplina, Professor professor) throws
      SIAlocacaoException;

  /*
   * Retorna um objeto disciplina contendo as informaoes da disciplina alocada
   * no horario e sala especificados.
   * @param horario
   * @return sala
   */
  public Disciplina getDisciplinaAlocada(Horario horario, Sala sala)
      throws SIAlocacaoException;


  /*
   * Altera Alocacao no sistema.
   * @param alocacao
   */
  public void alterarAlocacao(Alocacao alocacao) throws SIAlocacaoException;

  /*
   * Exclui Alocacao do sistema.
   * @param alocacao
   */
  public void excluirAlocacao(int codigo) throws SIAlocacaoException;

  /*
   * Lista alocacoes do sistema.
   * @return ArrayList
   */
  public ArrayList listarAlocacoes() throws SIAlocacaoException;

  /*
   * Retorna o objeto alocacao para horario e sala especificados.
   * @param horario
   * @return sala
   */
  public Alocacao getAlocacao(Horario horario, Sala sala) throws SIAlocacaoException,
      HorarioNaoAlocadoException;


}