package sialocacao.disciplina;

/**
 * <p>Title: Disciplina.java </p>
 * <p>Description: Responsvel por manipular o objeto disciplina. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public class Disciplina {

  /*
   * Cdigo da disciplina.
   */
  private int codigo;

  /*
   * Descrio da disciplina.
   */
  private String descricao;

  /*
   * Carga horria da disciplina.
   */
  private int cargaHoraria;

  /*
   * Ementa da disciplina.
   */
  private String ementa;

  /*
   * rea da disciplina.
   */
  private String area;


  /*
   * Construtor vazio.
   */
  public Disciplina() {
  }

  /*
   * Construtor responsvel por definir cdigo, descricao, carga horria, ementa e rea da disciplina.
   */
  public Disciplina(int codigo, String descricao, int cargaHoraria, String ementa, String area) {
    setCodigo(codigo);
    setDescricao(descricao);
    setCargaHoraria(cargaHoraria);
    setEmenta(ementa);
    setArea(area);
  }

  /*
   * Construtor responsvel por definir cdigo e descricao da disciplina.
   */
  public Disciplina(int codigo, String descricao) {
    setCodigo(codigo);
    setDescricao(descricao);
  }

  /**
   * Pega cdigo da disciplina.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo da disciplina.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega descrio da disciplina.
   * @return String
   */
  public String getDescricao() {
    return this.descricao;
  }

  /**
   * Define descrio da disciplina.
   * @param descricao
   */
  public void setDescricao(String descricao) {
    this.descricao = descricao;
  }

  /**
   * Pega carga horria da disciplina.
   * @return int
   */
  public int getCargaHoraria() {
    return this.cargaHoraria;
  }

  /**
   * Define carga horria da disciplina.
   * @param cargaHoraria
   */
  public void setCargaHoraria(int cargaHoraria) {
    this.cargaHoraria = cargaHoraria;
  }

  /**
   * Pega ementa da disciplina.
   * @return String
   */
  public String getEmenta() {
    return this.ementa;
  }

  /**
   * Define ementa da disciplina.
   * @param ementa
   */
  public void setEmenta(String ementa) {
    this.ementa = ementa;
  }

  /**
   * Pega rea da disciplina.
   * @return String
   */
  public String getArea() {
    return this.area;
  }

  /**
   * Define rea da disciplina.
   * @param area
   */
  public void setArea(String area) {
    this.area = area;
  }

  /**
   * Compara dois objetos disciplina.
   * @param disciplina
   * @return boolean
   */
  public boolean equals(Disciplina disciplina) {
    boolean result = false;

    if((this.codigo == disciplina.getCodigo()) &&
      (this.descricao.equalsIgnoreCase(disciplina.getDescricao().trim())) &&
      (this.cargaHoraria == disciplina.getCargaHoraria()) &&
      (this.ementa.equalsIgnoreCase(disciplina.getEmenta().trim())) &&
      (this.area.equalsIgnoreCase(disciplina.getArea().trim()))) {
        result = true;
    }
    return result;
}

  /**
   * Concatena atributos do objeto disciplina em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str = new StringBuffer();

    str.append("sialocacao.disciplina.Disciplina: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.descricao);
    str.append(", ");
    str.append(this.cargaHoraria);
    str.append(", ");
    str.append(this.ementa);
    str.append(", ");
    str.append(this.area);
    str.append(")");

    return str.toString();
  }
}