package sialocacao.horario;

/**
 * <p>Title: Horario.java </p>
 * <p>Description: Responsvel por manipular o objeto horario. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira 
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public class Horario {
  
  /*
   * Cdigo do horrio.
   */
  private int codigo;
  
  /*
   * Dia da semana do horrio.
   */
  private String diaDaSemana;
  
  /*
   * Hora de incio do horrio.
   */
  private String horaInicio;
  
  /*
   * Hora de fim do horrio.
   */
  private String horaFim;

  /*
   * Construtor vazio.
   */
  public Horario() {
  }

  /*
   * Construtor responsvel por definir cdigo, dia da semana, hora de incio 
   * e hora de fim do horrio.
   */
  public Horario(int codigo, String diaDaSemana, String horaInicio, String horaFim) {
    setCodigo(codigo);
    setDiaDaSemana(diaDaSemana);
    setHoraInicio(horaInicio);
    setHoraFim(horaFim);
  }

  /**
   * Pega cdigo do horrio.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo do horrio.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega dia da semana do horrio.
   * @return String
   */
  public String getDiaDaSemana() {
    return this.diaDaSemana;
  }

  /**
   * Define dia da semana do horrio.
   * @param diaDaSemana
   */
  public void setDiaDaSemana(String diaDaSemana) {
    this.diaDaSemana = diaDaSemana;
  }

  /**
   * Pega hora de nicio do horrio.
   * @return String
   */
  public String getHoraInicio() {
    return this.horaInicio;
  }

  /**
   * Define hora de incio do horrio.
   * @param horaInicio
   */
  public void setHoraInicio(String horaInicio) {
    this.horaInicio = horaInicio;
  }

  /**
   * Pega hora de fim do horrio.
   * @return String
   */
  public String getHoraFim() {
    return this.horaFim;
  }

  /**
   * Define hora de fim do horrio.
   * @param horaFim
   */
  public void setHoraFim(String horaFim) {
    this.horaFim = horaFim;
  }

  /**
   * Compara dois objetos disciplina.
   * @param disciplina
   * @return boolean
   */
  public boolean equals(Horario horario) {
    boolean result = false;

    if((this.codigo == horario.getCodigo()) &&
      (this.diaDaSemana.equalsIgnoreCase(horario.getDiaDaSemana().trim())) &&
      (this.horaInicio.equalsIgnoreCase(horario.getHoraInicio().trim())) &&
      (this.horaFim.equalsIgnoreCase(horario.getHoraFim().trim()))) {
        result = true;
    }
    return result;
  }

  /**
   * Concatena atributos do objeto horario em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str = new StringBuffer();

    str.append("sialocacao.horario.Horario: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.diaDaSemana);
    str.append(", ");
    str.append(this.horaInicio);
    str.append(", ");
    str.append(this.horaFim);
    str.append(")");

    return str.toString();
  }
}