package sialocacao.horario.database;

/**
 * <p>Title: IHorarioDatabase.java </p>
 * <p>Description: Interface da classe HorarioDatabase. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import java.util.*;

import sialocacao.*;
import sialocacao.horario.*;
import sialocacao.horario.excecoes.*;

public interface IHorarioDatabase {

  /*
   * Insere horrio no sistema.
   * @param diaDaSemana
   * @param horaInicio
   * @param horaFim
   */
  public void inserirHorario(String diaDaSemana, String horaInicio, String horaFim)
      throws SIAlocacaoException;

  /*
   * Altera horrio no sistema.
   * @param horario
   */
  public void alterarHorario(Horario horario) throws SIAlocacaoException,
      HorarioInexistenteException;

  /*
   * Exclui horrio do sistema pelo cdigo.
   * @param codigo
   */
  public void excluirHorario(int codigo) throws SIAlocacaoException,
      HorarioInexistenteException;

  /*
   * Busca horrio no sistema pelo cdigo.
   * @param codigo
   * @return Horario
   */
  public Horario buscarHorario(int codigo) throws SIAlocacaoException;

  /*
   * Busca horrio no sistema pelo cdigo.
   * @param diaDaSemana
   * @param horaInicio
   * @param horaFim
   * @return Horario
   */
  public Horario buscarHorario(String diaDaSemana, String horaInicio,
    String horaFim) throws SIAlocacaoException;

  /*
   * Lista horaiors do sistema.
   * @return ArrayList
   */
  public ArrayList listarHorarios() throws SIAlocacaoException,
      HorarioInexistenteException;

  /*
   * Lista horaiors do sistema.
   * @return ArrayList
   */
  public ArrayList listarHorariosDistintos() throws SIAlocacaoException,
      HorarioInexistenteException;
}