package sialocacao.alocacao;

/**
 * <p>Title: Alocacao.java </p>
 * <p>Description: Responsvel por manipular o objeto alocacao. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */


/**
 * <p>Title: SIAlocacao</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class Alocacao {
  /*
   * Cdigo da alocacao.
   */
  private int codigo;

  /*
   * Cdigo do Professor.
   */
  private int codProfessor;

  /*
   * Cdigo da Sala.
   */
  private int codSala;

  /*
   * Cdigo do Horario.
   */
  private int codHorario;

  /*
   * Cdigo da Disciplina.
   */
  private int codDisciplina;

  /*
   * Construtor vazio.
   */
  public Alocacao() {
  }

  /*
   * Construtor responsvel por definir cdigo, descricao, carga horria, ementa e rea da disciplina.
   */
  public Alocacao(int codigo, int codProfessor, int codSala, int codHorario, int codDisciplina) {
    setCodigo(codigo);
    setCodProfessor(codProfessor);
    setCodSala(codSala);
    setCodHorario(codHorario);
    setCodDisciplina(codDisciplina);
  }

  /**
   * Pega cdigo da Alocacao.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo da Alocacao.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega cdigo do Professor.
   * @return int
   */
  public int getCodProfessor() {
    return this.codProfessor;
  }

  /**
   * Define cdigo do Professor.
   * @param codProfessor
   */
  public void setCodProfessor(int codProfessor) {
    this.codProfessor = codProfessor;
  }

  /**
   * Pega cdigo da Sala.
   * @return int
   */
  public int getCodSala() {
    return this.codSala;
  }

  /**
   * Define cdigo da Sala.
   * @param codSala
   */
  public void setCodSala(int codSala) {
    this.codSala = codSala;
  }

  /**
   * Pega cdigo do Horario.
   * @return int
   */
  public int getCodHorario() {
    return this.codHorario;
  }

  /**
   * Define cdigo do Horario.
   * @param codSala
   */
  public void setCodHorario(int codHorario) {
    this.codHorario = codHorario;
  }

  /**
   * Pega cdigo da Disciplina.
   * @return int
   */
  public int getCodDisciplina() {
    return this.codDisciplina;
  }

  /**
   * Define cdigo do Disciplina.
   * @param codDisciplina
   */
  public void setCodDisciplina(int codDisciplina) {
    this.codDisciplina = codDisciplina;
  }


  /**
   * Compara dois objetos disciplina.
   * @param disciplina
   * @return boolean
   */
  public boolean equals(Alocacao alocacao) {
    boolean result = false;

    if((this.codigo == alocacao.getCodigo()) &&
       (this.codProfessor == alocacao.getCodProfessor()) &&
       (this.codHorario == alocacao.getCodHorario()) &&
       (this.codSala == alocacao.getCodSala()) &&
       (this.codDisciplina == alocacao.getCodDisciplina()) )

      result = true;

    return result;
  }

  /**
   * Concatena atributos do objeto disciplina em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str = new StringBuffer();

    str.append("sialocacao.alocacao.Alocacao: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.codProfessor);
    str.append(", ");
    str.append(this.codHorario);
    str.append(", ");
    str.append(this.codSala);
    str.append(", ");
    str.append(this.codDisciplina);
    str.append(")");

    return str.toString();
  }

}