package sialocacao.disciplina.excecoes;

/**
 * <p>Title: DisciplinaInexistenteException.java </p>
 * <p>Description: Responsvel por tratar exceo de disciplina inexistente. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import sialocacao.*;
import sialocacao.disciplina.*;

public class DisciplinaAlocadaException extends SIAlocacaoException {

  /*
   * Construtor responsvel por definir o cdigo da disciplina inexistente.
   */
  public DisciplinaAlocadaException() {
  }

  /*
   * Construtor responsvel por definir o cdigo da disciplina inexistente.
   */
  public DisciplinaAlocadaException(int codDisciplina) {
    setDescription(getDescription(codDisciplina));
  }

  /*
   * Construtor responsvel por definir a descricao da disciplina inexistente.
   */
  public DisciplinaAlocadaException(String descricao) {
    setDescription(getDescription(descricao));
  }

  /*
   * Construtor responsvel por definir a disciplina inexistente.
   */
  public DisciplinaAlocadaException(Disciplina disciplina)
      throws IllegalArgumentException {
    if (disciplina == null) {
      throw new IllegalArgumentException("dsiciplina == null");
    }
    setDescription(getDescription(disciplina.getCodigo()));
  }

  /*
   * Define descrio da exceo, passando o cdigo da disciplina inexistente.
   * @param codDisciplina
   */
  private String getDescription(int codDisciplina) {
    StringBuffer description = new StringBuffer( "Nao existe disciplina com o codigo ");

    description.append(codDisciplina);

    return description.toString();
  }

  /*
   * Define descrio da exceo, passando a descricao da disciplina inexistente.
   * @param codDisciplina
   */
  private String getDescription(String descricao) {
    StringBuffer description = new StringBuffer( "Nao existe disciplina com o codigo ");

    description.append(descricao);

    return description.toString();
  }
}