package sialocacao.professor;

/**
 * <p>Title: Professor.java </p>
 * <p>Description: Responsvel por manipular o objeto professor. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public class Professor {

  /*
   * Cdigo do professor.
   */
  private int codigo;

  /*
   * Nome do professor.
   */
  private String nome;

  /*
   * rea do professor.
   */
  private String area;

  /*
   * Construtor vazio.
   */
  public Professor() {
  }

  /*
   * Construtor responsvel por definir cdigo, nome e area do professor.
   */
  public Professor(int codigo, String nome, String area) {
    setCodigo(codigo);
    setNome(nome);
    setArea(area);
  }

  /**
   * Pega cdigo do professor.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo do professor.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega nome do professor.
   * @return String
   */
  public String getNome() {
    return this.nome;
  }

  /**
   * Define nome do professor.
   * @param nome
   */
  public void setNome(String nome) {
    this.nome = nome;
  }

  /**
   * Pega rea do professor.
   * @return String
   */
  public String getArea() {
    return this.area;
  }

  /**
   * Define rea do professor.
   * @param area
   */
  public void setArea(String area) {
    this.area = area;
  }

  /**
   * Compara dois objetos professor.
   * @param professor
   * @return boolean
   */
  public boolean equals(Professor professor) {
    boolean result = false;

    if((this.codigo == professor.getCodigo()) &&
      (this.nome.equalsIgnoreCase(professor.getNome().trim())) &&
      (this.area.equalsIgnoreCase(professor.getArea().trim()))) {
        result = true;
    }
    return result;
  }

  /**
   * Concatena atributos do objeto professor em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str =
        new StringBuffer();

    str.append("sialocacao.professor.Professor: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.nome);
    str.append(", ");
    str.append(this.area);
    str.append(")");

    return str.toString();
  }
}