package sialocacao.professor.excecoes;

/**
 * <p>Title: ProfessorInexistenteException.java </p>
 * <p>Description: Responsvel por tratar exceo de professor inexistente. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

import sialocacao.*;
import sialocacao.professor.*;

public class ProfessorAlocadoException extends SIAlocacaoException {

  /*
   * Construtor responsvel por definir o cdigo do professor inexistente.
   */
  public ProfessorAlocadoException() {
  }


  /*
   * Construtor responsvel por definir o cdigo do professor inexistente.
   */
  public ProfessorAlocadoException(int codProfessor) {
    setDescription(getDescription(codProfessor));
  }

  /*
   * Construtor responsvel por definir o nome do professor inexistente.
   */
  public ProfessorAlocadoException(String nome) {
    setDescription(getDescription(nome));
  }

  /*
   * Construtor responsvel por definir o professor inexistente.
   */
  public ProfessorAlocadoException(Professor professor) throws
      IllegalArgumentException {

    if (professor == null) {
      throw new IllegalArgumentException("professor == null");
    }

    setDescription(getDescription(professor.getCodigo()));
  }

  /*
   * Define descrio da exceo, passando o cdigo do professor inexistente.
   * @param codDisciplina
   */
  private String getDescription(int codProfessor) {
    StringBuffer description =
        new StringBuffer("O professor com o codigo ");

    description.append(codProfessor);

    description.append(" j est alocado!");

    return description.toString();
  }

  /*
   * Define descrio da exceo, passando o nome do professor inexistente.
   * @param nome
   */
  private String getDescription(String nome) {
    StringBuffer description =
        new StringBuffer("O professor ");

    description.append(nome);

    description.append(" j est alocado!");

    return description.toString();
  }
}