package sialocacao.professor.fachada;

import sialocacao.professor.Professor;
import sialocacao.professor.excecoes.ProfessorInexistenteException;
import sialocacao.SIAlocacaoException;

import java.util.ArrayList;

/**
 * <p>Title: IRegistroProfessores</p>
 * <p>Description: Interface que define as opera\uFFFD\uFFFDes poss\uFFFDveis para professores </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author fabrica 3
 * @version 1.0
 */

public interface IRegistroProfessores {

/**
 * M\uFFFDtodo para efetuar a inser\uFFFD\uFFFDo de um professor.
 * @param nome Nome do professor
 * @param area Area para qual o professor leciona
 */
  public void inserirProfessor(String nome, String area)
    throws SIAlocacaoException;


/**
  * M\uFFFDtodo para efetuar a atualiza\uFFFD\uFFFDo dos dados de um professor.
  * @param professor Objeto professor contendo os novos dados a serem armazenados
  */
  public void alterarProfessor(Professor professor)
    throws SIAlocacaoException, ProfessorInexistenteException;

/**
 * M\uFFFDtodo para efetuar a exclus\uFFFDo de um professor.
 * @param codigo Codigo identificador do professor a ser exclu\uFFFDdo
 */
  public void excluirProfessor(int codigo)
    throws SIAlocacaoException, ProfessorInexistenteException;

/**
 * M\uFFFDtodo para efetuar a busca de um professor.
 * @param codigo Codigo identificador do professor procurado
 */
  public Professor buscarProfessor(int codigo)
    throws SIAlocacaoException, ProfessorInexistenteException;

/**
 * M\uFFFDtodo para recuperar a listagem de todos os professores.
 * @return Uma listagem de todos os professores
 */
  public ArrayList listarProfessores()
    throws SIAlocacaoException, ProfessorInexistenteException;
}