package sialocacao.sala;

/**
 * <p>Title: Sala.java </p>
 * <p>Description: Responsvel por manipular o objeto sala. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Fbrica III </p>
 * @author: Carlos A. Rego Andrade
 *          Fbio de Carvalho Dias Ferreira
 *          Luiz Eduardo Cunha Leite
 *          Taciana Amorim Vanderlei
 *          Vivianne da Nbrega Medeiros
 * @version 1.0
 */

public class Sala {

  /*
   * Cdigo da sala.
   */
  private int codigo;

  /*
   * Descrio da sala.
   */
  private String descricao;

  /*
   * Localizao da sala.
   */
  private String localizacao;

  /*
   * Observao da sala.
   */
  private String observacao;

  /*
   * Construtor vazio.
   */
  public Sala() {
  }

  /*
   * Construtor responsvel por definir cdigo, descrio, localizao
   * e observao da sala.
   */
  public Sala(int codigo, String descricao, String localizacao, String observacao) {
    setCodigo(codigo);
    setDescricao(descricao);
    setLocalizacao(localizacao);
    setObservacao(observacao);
  }

  /**
   * Pega cdigo da sala.
   * @return int
   */
  public int getCodigo() {
    return this.codigo;
  }

  /**
   * Define cdigo da sala.
   * @param codigo
   */
  public void setCodigo(int codigo) {
    this.codigo = codigo;
  }

  /**
   * Pega descrio da sala.
   * @return int
   */
  public String getDescricao() {
    return this.descricao;
  }

  /**
   * Define descrio da sala.
   * @param descricao
   */
  public void setDescricao(String descricao) {
    this.descricao = descricao;
  }

  /**
   * Pega localizao da sala.
   * @return int
   */
  public String getLocalizacao() {
    return this.localizacao;
  }

  /**
   * Define localizao da sala.
   * @param localizacao
   */
  public void setLocalizacao(String localizacao) {
    this.localizacao = localizacao;
  }

  /**
   * Pega observao da sala.
   * @return int
   */
  public String getObservacao() {
    return this.observacao;
  }

  /**
   * Define observao da sala.
   * @param observacao
   */
  public void setObservacao(String observacao) {
    this.observacao = observacao;
  }

  /**
   * Compara dois objetos sala.
   * @param sala
   * @return boolean
   */
  public boolean equals(Sala sala) {
    boolean result = false;

    if((this.codigo == sala.getCodigo()) &&
      (this.descricao.equalsIgnoreCase(sala.getDescricao().trim())) &&
      (this.localizacao.equalsIgnoreCase(sala.getLocalizacao().trim())) &&
      (this.observacao.equalsIgnoreCase(sala.getObservacao().trim()))) {
        result = true;
    }
    return result;
  }

  /**
   * Concatena atributos do objeto sala em uma string.
   * @return String
   */
  public String toString() {
    StringBuffer str =
        new StringBuffer();

    str.append("sialocacao.sala.Sala: (");
    str.append(this.codigo);
    str.append(", ");
    str.append(this.descricao);
    str.append(", ");
    str.append(this.localizacao);
    str.append(", ");
    str.append(this.observacao);
    str.append(")");

    return str.toString();
  }
}